unit UnitGocciaAcqua;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, Math, XPMan, ComCtrls;

type
  TForm1 = class(TForm)
    Image: TImage;
    XPManifest1: TXPManifest;
    Panel1: TPanel;
    LabeledEditAI: TLabeledEdit;
    LabeledEditR: TLabeledEdit;
    BitBtnStart: TBitBtn;
    BitBtnCancella: TBitBtn;
    CheckBoxRosso: TCheckBox;
    CheckBoxArancio: TCheckBox;
    CheckBoxGiallo: TCheckBox;
    CheckBoxVerde: TCheckBox;
    CheckBoxBlu: TCheckBox;
    CheckBoxIndaco: TCheckBox;
    CheckBoxViola: TCheckBox;
    UpDownAI: TUpDown;
    Label1: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    LabelRosso: TLabel;
    LAbelArancio: TLabel;
    LabelGiallo: TLabel;
    LabelVerde: TLabel;
    LabelBlu: TLabel;
    LabelIndaco: TLabel;
    LabelViola: TLabel;
    UpDown1: TUpDown;
    procedure BitBtnCancellaClick(Sender: TObject);
    procedure BitBtnStartClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.BitBtnCancellaClick(Sender: TObject);
var r, xx, xy, yx, yy: integer;
begin
  r:=strtoint(labelededitR.text);
  Image.Picture:=nil;
  Image.Canvas.Brush.Color:=clwhite;
  Image.Canvas.FillRect(rect(0,0,Image.Width,Image.Height));
  Image.Canvas.Pen.color:=clblack;
  Image.Canvas.Ellipse(Image.Width div 2 - r, Image.Height div 2 - r, Image.Width div 2 + r, Image.Height div 2 + r);
  image.Canvas.Brush.Style:=bsclear;
  image.Canvas.font.color:=clblack;
  label1.visible:=false;
  label2.visible:=false;
  label3.visible:=false;
  label4.visible:=false;
  label5.visible:=false;
  label6.visible:=false;
  label7.visible:=false;
  LabelRosso.Caption:='';
  LabelArancio.Caption:='';
  LabelGiallo.Caption:='';
  LabelVerde.Caption:='';
  LabelBlu.Caption:='';
  LabelIndaco.Caption:='';
  LabelViola.Caption:='';
  bitbtnstart.Enabled:=true;
   for xx:=-(image.Width div 2) to (image.Width div 2) do
    begin
      yx:=0;
      Image.Canvas.Pixels[xx+(image.Width div 2),-yx+(Image.Height div 2)]:=clblack;
    end;
  for yy:=-(image.Width div 2) to (image.Width div 2) do
    begin
      xy:=0;
      Image.Canvas.Pixels[xy+(image.Width div 2),-yy+(Image.Height div 2)]:=clblack;
    end;
end;

procedure TForm1.BitBtnStartClick(Sender: TObject);
const pi=3.14;
      ir=1.3310;
      ia=1.3320;
      ig=1.3336;
      ive=1.3357;
      ib=1.3380;
      ii=1.3412;
      ivi=1.3448;
      iar=1.000292;
var r, xx, xy, yx, yy, x1, x2, x3, x4, x5, x6, x7, y1, y2, y3, y4, y5, y6, y7: integer;
    a1, a2, a3, a4, m1, m2, m3, m4, m5, m6, m7, q1, q2, q3, q4, q5, q6, q7, xp1, xp2, xp3, xp4, xp5, yp1, yp2, yp3, yp4, yp5: double;
begin
  r:=strtoint(labelededitR.text);
  Image.Picture:=nil;
  Image.Canvas.Brush.Color:=clwhite;
  Image.Canvas.FillRect(rect(0,0,Image.Width,Image.Height));
  Image.Canvas.Pen.color:=clblack;
  Image.Canvas.Ellipse(Image.Width div 2 - r, Image.Height div 2 - r, Image.Width div 2 + r, Image.Height div 2 + r);
  image.Canvas.Brush.Style:=bsclear;
  image.Canvas.font.color:=clblack;
  for xx:=-(image.Width div 2) to (image.Width div 2) do
    begin
      yx:=0;
      Image.Canvas.Pixels[xx+(image.Width div 2),-yx+(Image.Height div 2)]:=clblack;
    end;
  for yy:=-(image.Width div 2) to (image.Width div 2) do
    begin
      xy:=0;
      Image.Canvas.Pixels[xy+(image.Width div 2),-yy+(Image.Height div 2)]:=clblack;
    end;

  if Checkboxrosso.Checked = true then
  begin
  a1:=degtorad(strtofloat(labelededitAI.text));
  m1:=tan(degtorad(180)-a1);
  q1:=0;
  for x1:=-(image.Width div 2) to 0 do
    begin
      y1:=round(m1*x1+q1);
      if Sqr(x1)+Sqr(y1)<Sqr(r) then
        Image.Canvas.Pixels[x1+(image.Width div 2),-y1+(Image.Height div 2)]:=clred;
    end;
  m2:=0;
  xp1:=(-m1*q1-sqrt(sqr(m1*q1)-(sqr(m1)+1)*(sqr(q1)-sqr(r))))/(sqr(m1)+1);
  yp1:=m1*xp1+q1;
  q2:=-m2*xp1+yp1;
  for x2:=-(image.Width div 2) to (image.Width div 2) do
    begin
      y2:=round(-m2*x2+q2);
      Image.Canvas.Pixels[x2+(image.Width div 2),-y2+(Image.Height div 2)]:=clred;
    end;
  a2:=arcsin(sin(a1)/(ir/iar));
  m3:=tan (degtorad(180)-a1+a2);
  q3:=+yp1-m3*xp1;
  for x3:=-(image.Width div 2) to (image.Width div 2) do
  begin
    y3:=round(m3*x3+q3);
    if Sqr(x3)+Sqr(y3)<Sqr(r) then
      Image.Canvas.Pixels[x3+(image.Width div 2),-y3+(Image.Height div 2)]:=clred;
  end;
  m4:=tan(3*a2-a1);
  xp2:=(-m3*q3+sqrt(sqr(m3*q3)-(sqr(m3)+1)*(sqr(q3)-sqr(r))))/(sqr(m3)+1);
  yp2:=m3*xp2+q3;
  q4:=+yp2-m4*xp2;
  for x4:=-(image.Width div 2) to (image.Width div 2) do
    begin
      y4:=round(m4*x4+q4);
      if Sqr(x4)+Sqr(y4)<Sqr(r) then
        Image.Canvas.Pixels[x4+(image.Width div 2),-y4+(Image.Height div 2)]:=clred;
    end;
  m5:=yp2/xp2;
  q5:=0;
  for x5:=0 to (image.Width div 2) do
    begin
      y5:=round(m5*x5+q5);
      Image.Canvas.Pixels[x5+(image.Width div 2),-y5+(Image.Height div 2)]:=clred;
    end;
  xp3:=(-m4*q4-sqrt(sqr(m4*q4)-(sqr(m4)+1)*(sqr(q4)-sqr(r))))/(sqr(m4)+1);
  yp3:=m4*xp3+q4;
  xp4:=(q2-q5)/(m5-m2);
  yp4:=m5*xp4+q5;
  m6:=(yp3-yp4)/(xp3-xp4);
  q6:=yp4-m6*xp4;
  for x6:=-(image.Width div 2) to (image.Width div 2) do
    begin
      y6:=round(m6*x6+q6);
      Image.Canvas.Pixels[x6+(image.Width div 2),-y6+(Image.Height div 2)]:=clred;
    end;
  xp5:=(-m4*q4-sqrt(sqr(m4*q4)-(sqr(m4)+1)*(sqr(q4)-sqr(r))))/(sqr(m4)+1);
  yp5:=m4*xp3+q4;
  m7:=yp5/xp5;
  q7:=0;
  if m7<0 then
    for x7:=0 to (image.Width div 2) do
      begin
        y7:=round(m7*x7+q7);
        if Sqr(x7)+Sqr(y7)<Sqr(r) then
          Image.Canvas.Pixels[x7+(image.Width div 2),-y7+(Image.Height div 2)]:=clred;
      end
  else
    for x7:=-(image.Width div 2) to 0 do
      begin
        y7:=round(m7*x7+q7);
        if Sqr(x7)+Sqr(y7)<Sqr(r) then
          Image.Canvas.Pixels[x7+(image.Width div 2),-y7+(Image.Height div 2)]:=clred;
      end;
  label1.visible:=true;
  LabelRosso.Caption:=floattostr(arctan(m5));
  end;

  if checkboxArancio.Checked = true then
  begin
  a1:=degtorad(strtofloat(labelededitAI.text));
  m1:=tan(degtorad(180)-a1);
  q1:=0;
  for x1:=-(image.Width div 2) to 0 do
    begin
      y1:=round(m1*x1+q1);
      if Sqr(x1)+Sqr(y1)<Sqr(r) then
      Image.Canvas.Pixels[x1+(image.Width div 2),-y1+(Image.Height div 2)]:=rgb(255,160,0);
    end;
  m2:=0;
  xp1:=(-m1*q1-sqrt(sqr(m1*q1)-(sqr(m1)+1)*(sqr(q1)-sqr(r))))/(sqr(m1)+1);
  yp1:=m1*xp1+q1;
  q2:=-m2*xp1+yp1;
  for x2:=-(image.Width div 2) to (image.Width div 2) do
    begin
      y2:=round(-m2*x2+q2);
      Image.Canvas.Pixels[x2+(image.Width div 2),-y2+(Image.Height div 2)]:=rgb(255,160,0);
    end;
  a2:=arcsin(sin(a1)/(ia/iar));
  m3:=tan (degtorad(180)-a1+a2);
  q3:=+yp1-m3*xp1;
  for x3:=-(image.Width div 2) to (image.Width div 2) do
  begin
    y3:=round(m3*x3+q3);
    if Sqr(x3)+Sqr(y3)<Sqr(r) then
    Image.Canvas.Pixels[x3+(image.Width div 2),-y3+(Image.Height div 2)]:=rgb(255,160,0);
  end;
  m4:=tan(3*a2-a1);
  xp2:=(-m3*q3+sqrt(sqr(m3*q3)-(sqr(m3)+1)*(sqr(q3)-sqr(r))))/(sqr(m3)+1);
  yp2:=m3*xp2+q3;
  q4:=+yp2-m4*xp2;
  for x4:=-(image.Width div 2) to (image.Width div 2) do
    begin
      y4:=round(m4*x4+q4);
      if Sqr(x4)+Sqr(y4)<Sqr(r) then
      Image.Canvas.Pixels[x4+(image.Width div 2),-y4+(Image.Height div 2)]:=rgb(255,160,0);
    end;
  m5:=yp2/xp2;
  q5:=0;
  for x5:=0 to (image.Width div 2) do
    begin
      y5:=round(m5*x5+q5);
      Image.Canvas.Pixels[x5+(image.Width div 2),-y5+(Image.Height div 2)]:=rgb(255,160,0);
    end;
  xp3:=(-m4*q4-sqrt(sqr(m4*q4)-(sqr(m4)+1)*(sqr(q4)-sqr(r))))/(sqr(m4)+1);
  yp3:=m4*xp3+q4;
  xp4:=(q2-q5)/(m5-m2);
  yp4:=m5*xp4+q5;
  m6:=(yp3-yp4)/(xp3-xp4);
  q6:=yp4-m6*xp4;
  for x6:=-(image.Width div 2) to (image.Width div 2) do
    begin
      y6:=round(m6*x6+q6);
      Image.Canvas.Pixels[x6+(image.Width div 2),-y6+(Image.Height div 2)]:=rgb(255,160,0);
    end;
  xp5:=(-m4*q4-sqrt(sqr(m4*q4)-(sqr(m4)+1)*(sqr(q4)-sqr(r))))/(sqr(m4)+1);
  yp5:=m4*xp3+q4;
  m7:=yp5/xp5;
  q7:=0;
  if m7<0 then
     for x7:=0 to (image.Width div 2) do
      begin
        y7:=round(m7*x7+q7);
        if Sqr(x7)+Sqr(y7)<Sqr(r) then
        Image.Canvas.Pixels[x7+(image.Width div 2),-y7+(Image.Height div 2)]:=rgb(255,160,0);
      end
  else
    for x7:=-(image.Width div 2) to 0 do
      begin
        y7:=round(m7*x7+q7);
        if Sqr(x7)+Sqr(y7)<Sqr(r) then
        Image.Canvas.Pixels[x7+(image.Width div 2),-y7+(Image.Height div 2)]:=rgb(255,160,0);
      end;
  label2.visible:=true;
  LabelArancio.Caption:=floattostr(arctan(m5));
  end;

  if checkboxGiallo.Checked = true then
  begin
  a1:=degtorad(strtofloat(labelededitAI.text));
  m1:=tan(degtorad(180)-a1);
  q1:=0;
  for x1:=-(image.Width div 2) to 0 do
    begin
      y1:=round(m1*x1+q1);
      if Sqr(x1)+Sqr(y1)<Sqr(r) then
      Image.Canvas.Pixels[x1+(image.Width div 2),-y1+(Image.Height div 2)]:=clyellow;
    end;
  m2:=0;
  xp1:=(-m1*q1-sqrt(sqr(m1*q1)-(sqr(m1)+1)*(sqr(q1)-sqr(r))))/(sqr(m1)+1);
  yp1:=m1*xp1+q1;
  q2:=-m2*xp1+yp1;
  for x2:=-(image.Width div 2) to (image.Width div 2) do
    begin
      y2:=round(-m2*x2+q2);
      Image.Canvas.Pixels[x2+(image.Width div 2),-y2+(Image.Height div 2)]:=clyellow;
    end;
  a2:=arcsin(sin(a1)/(ig/iar));
  m3:=tan (degtorad(180)-a1+a2);
  q3:=+yp1-m3*xp1;
  for x3:=-(image.Width div 2) to (image.Width div 2) do
  begin
    y3:=round(m3*x3+q3);
    if Sqr(x3)+Sqr(y3)<Sqr(r) then
    Image.Canvas.Pixels[x3+(image.Width div 2),-y3+(Image.Height div 2)]:=clyellow;
  end;
  m4:=tan(3*a2-a1);
  xp2:=(-m3*q3+sqrt(sqr(m3*q3)-(sqr(m3)+1)*(sqr(q3)-sqr(r))))/(sqr(m3)+1);
  yp2:=m3*xp2+q3;
  q4:=+yp2-m4*xp2;
  for x4:=-(image.Width div 2) to (image.Width div 2) do
    begin
      y4:=round(m4*x4+q4);
      if Sqr(x4)+Sqr(y4)<Sqr(r) then
      Image.Canvas.Pixels[x4+(image.Width div 2),-y4+(Image.Height div 2)]:=clyellow;
    end;
  m5:=yp2/xp2;
  q5:=0;
  for x5:=0 to (image.Width div 2) do
    begin
      y5:=round(m5*x5+q5);
      Image.Canvas.Pixels[x5+(image.Width div 2),-y5+(Image.Height div 2)]:=clyellow;
    end;
  xp3:=(-m4*q4-sqrt(sqr(m4*q4)-(sqr(m4)+1)*(sqr(q4)-sqr(r))))/(sqr(m4)+1);
  yp3:=m4*xp3+q4;
  xp4:=(q2-q5)/(m5-m2);
  yp4:=m5*xp4+q5;
  m6:=(yp3-yp4)/(xp3-xp4);
  q6:=yp4-m6*xp4;
  for x6:=-(image.Width div 2) to (image.Width div 2) do
    begin
      y6:=round(m6*x6+q6);
      Image.Canvas.Pixels[x6+(image.Width div 2),-y6+(Image.Height div 2)]:=clyellow;
    end;
  xp5:=(-m4*q4-sqrt(sqr(m4*q4)-(sqr(m4)+1)*(sqr(q4)-sqr(r))))/(sqr(m4)+1);
  yp5:=m4*xp3+q4;
  m7:=yp5/xp5;
  q7:=0;
  if m7<0 then
    for x7:=0 to (image.Width div 2) do
      begin
        y7:=round(m7*x7+q7);
        if Sqr(x7)+Sqr(y7)<Sqr(r) then
        Image.Canvas.Pixels[x7+(image.Width div 2),-y7+(Image.Height div 2)]:=clyellow;
      end
   else
    for x7:=-(image.Width div 2) to 0 do
      begin
          y7:=round(m7*x7+q7);
          if Sqr(x7)+Sqr(y7)<Sqr(r) then
          Image.Canvas.Pixels[x7+(image.Width div 2),-y7+(Image.Height div 2)]:=clyellow;
      end;
  label3.visible:=true;
  LabelGiallo.Caption:=floattostr(arctan(m5));
  end;

  if checkboxVerde.Checked = true then
  begin
  a1:=degtorad(strtofloat(labelededitAI.text));
  m1:=tan(degtorad(180)-a1);
  q1:=0;
  for x1:=-(image.Width div 2) to 0 do
    begin
      y1:=round(m1*x1+q1);
      if Sqr(x1)+Sqr(y1)<Sqr(r) then
      Image.Canvas.Pixels[x1+(image.Width div 2),-y1+(Image.Height div 2)]:=clgreen;
    end;
  m2:=0;
  xp1:=(-m1*q1-sqrt(sqr(m1*q1)-(sqr(m1)+1)*(sqr(q1)-sqr(r))))/(sqr(m1)+1);
  yp1:=m1*xp1+q1;
  q2:=-m2*xp1+yp1;
  for x2:=-(image.Width div 2) to (image.Width div 2) do
    begin
      y2:=round(-m2*x2+q2);
      Image.Canvas.Pixels[x2+(image.Width div 2),-y2+(Image.Height div 2)]:=clgreen;
    end;
  a2:=arcsin(sin(a1)/(ive/iar));
  m3:=tan (degtorad(180)-a1+a2);
  q3:=+yp1-m3*xp1;
  for x3:=-(image.Width div 2) to (image.Width div 2) do
  begin
    y3:=round(m3*x3+q3);
    if Sqr(x3)+Sqr(y3)<Sqr(r) then
    Image.Canvas.Pixels[x3+(image.Width div 2),-y3+(Image.Height div 2)]:=clgreen;
  end;
  m4:=tan(3*a2-a1);
  xp2:=(-m3*q3+sqrt(sqr(m3*q3)-(sqr(m3)+1)*(sqr(q3)-sqr(r))))/(sqr(m3)+1);
  yp2:=m3*xp2+q3;
  q4:=+yp2-m4*xp2;
  for x4:=-(image.Width div 2) to (image.Width div 2) do
    begin
      y4:=round(m4*x4+q4);
      if Sqr(x4)+Sqr(y4)<Sqr(r) then
      Image.Canvas.Pixels[x4+(image.Width div 2),-y4+(Image.Height div 2)]:=clgreen;
    end;
  m5:=yp2/xp2;
  q5:=0;
  for x5:=0 to (image.Width div 2) do
    begin
      y5:=round(m5*x5+q5);
      Image.Canvas.Pixels[x5+(image.Width div 2),-y5+(Image.Height div 2)]:=clgreen;
    end;
  xp3:=(-m4*q4-sqrt(sqr(m4*q4)-(sqr(m4)+1)*(sqr(q4)-sqr(r))))/(sqr(m4)+1);
  yp3:=m4*xp3+q4;
  xp4:=(q2-q5)/(m5-m2);
  yp4:=m5*xp4+q5;
  m6:=(yp3-yp4)/(xp3-xp4);
  q6:=yp4-m6*xp4;
  for x6:=-(image.Width div 2) to (image.Width div 2) do
    begin
      y6:=round(m6*x6+q6);
      Image.Canvas.Pixels[x6+(image.Width div 2),-y6+(Image.Height div 2)]:=clgreen;
    end;
  xp5:=(-m4*q4-sqrt(sqr(m4*q4)-(sqr(m4)+1)*(sqr(q4)-sqr(r))))/(sqr(m4)+1);
  yp5:=m4*xp3+q4;
  m7:=yp5/xp5;
  q7:=0;
  if m7<0 then
    for x7:=0 to (image.Width div 2) do
      begin
        y7:=round(m7*x7+q7);
        if Sqr(x7)+Sqr(y7)<Sqr(r) then
        Image.Canvas.Pixels[x7+(image.Width div 2),-y7+(Image.Height div 2)]:=clgreen;
      end
   else
    for x7:=-(image.Width div 2) to 0 do
      begin
        y7:=round(m7*x7+q7);
        if Sqr(x7)+Sqr(y7)<Sqr(r) then
        Image.Canvas.Pixels[x7+(image.Width div 2),-y7+(Image.Height div 2)]:=clgreen;
      end;
  label4.visible:=true;
  LabelVerde.Caption:=floattostr(arctan(m5));
  end;

  if checkboxBlu.Checked = true then
  begin
  a1:=degtorad(strtofloat(labelededitAI.text));
  m1:=tan(degtorad(180)-a1);
  q1:=0;
  for x1:=-(image.Width div 2) to 0 do
    begin
      y1:=round(m1*x1+q1);
      if Sqr(x1)+Sqr(y1)<Sqr(r) then
      Image.Canvas.Pixels[x1+(image.Width div 2),-y1+(Image.Height div 2)]:=claqua;
    end;
  m2:=0;
  xp1:=(-m1*q1-sqrt(sqr(m1*q1)-(sqr(m1)+1)*(sqr(q1)-sqr(r))))/(sqr(m1)+1);
  yp1:=m1*xp1+q1;
  q2:=-m2*xp1+yp1;
  for x2:=-(image.Width div 2) to (image.Width div 2) do
    begin
      y2:=round(-m2*x2+q2);
      Image.Canvas.Pixels[x2+(image.Width div 2),-y2+(Image.Height div 2)]:=claqua;
    end;
  a2:=arcsin(sin(a1)/(ib/iar));
  m3:=tan (degtorad(180)-a1+a2);
  q3:=+yp1-m3*xp1;
  for x3:=-(image.Width div 2) to (image.Width div 2) do
  begin
    y3:=round(m3*x3+q3);
    if Sqr(x3)+Sqr(y3)<Sqr(r) then
    Image.Canvas.Pixels[x3+(image.Width div 2),-y3+(Image.Height div 2)]:=claqua;
  end;
  m4:=tan(3*a2-a1);
  xp2:=(-m3*q3+sqrt(sqr(m3*q3)-(sqr(m3)+1)*(sqr(q3)-sqr(r))))/(sqr(m3)+1);
  yp2:=m3*xp2+q3;
  q4:=+yp2-m4*xp2;
  for x4:=-(image.Width div 2) to (image.Width div 2) do
    begin
      y4:=round(m4*x4+q4);
      if Sqr(x4)+Sqr(y4)<Sqr(r) then
      Image.Canvas.Pixels[x4+(image.Width div 2),-y4+(Image.Height div 2)]:=claqua;
    end;
  m5:=yp2/xp2;
  q5:=0;
  for x5:=0 to (image.Width div 2) do
    begin
      y5:=round(m5*x5+q5);
      Image.Canvas.Pixels[x5+(image.Width div 2),-y5+(Image.Height div 2)]:=claqua;
    end;
  xp3:=(-m4*q4-sqrt(sqr(m4*q4)-(sqr(m4)+1)*(sqr(q4)-sqr(r))))/(sqr(m4)+1);
  yp3:=m4*xp3+q4;
  xp4:=(q2-q5)/(m5-m2);
  yp4:=m5*xp4+q5;
  m6:=(yp3-yp4)/(xp3-xp4);
  q6:=yp4-m6*xp4;
  for x6:=-(image.Width div 2) to (image.Width div 2) do
    begin
      y6:=round(m6*x6+q6);
      Image.Canvas.Pixels[x6+(image.Width div 2),-y6+(Image.Height div 2)]:=claqua;
    end;
  xp5:=(-m4*q4-sqrt(sqr(m4*q4)-(sqr(m4)+1)*(sqr(q4)-sqr(r))))/(sqr(m4)+1);
  yp5:=m4*xp3+q4;
  m7:=yp5/xp5;
  q7:=0;
  if m7<0 then
    for x7:=0 to (image.Width div 2) do
      begin
        y7:=round(m7*x7+q7);
        if Sqr(x7)+Sqr(y7)<Sqr(r) then
        Image.Canvas.Pixels[x7+(image.Width div 2),-y7+(Image.Height div 2)]:=claqua;
      end
   else
    for x7:=-(image.Width div 2) to 0 do
      begin
        y7:=round(m7*x7+q7);
        if Sqr(x7)+Sqr(y7)<Sqr(r) then
        Image.Canvas.Pixels[x7+(image.Width div 2),-y7+(Image.Height div 2)]:=claqua;
      end;
  label5.visible:=true;
  LabelBlu.Caption:=floattostr(arctan(m5));
  end;

  if checkboxIndaco.Checked = true then
  begin
  a1:=degtorad(strtofloat(labelededitAI.text));
  m1:=tan(degtorad(180)-a1);
  q1:=0;
  for x1:=-(image.Width div 2) to 0 do
    begin
      y1:=round(m1*x1+q1);
      if Sqr(x1)+Sqr(y1)<Sqr(r) then
      Image.Canvas.Pixels[x1+(image.Width div 2),-y1+(Image.Height div 2)]:=clblue;
    end;
  m2:=0;
  xp1:=(-m1*q1-sqrt(sqr(m1*q1)-(sqr(m1)+1)*(sqr(q1)-sqr(r))))/(sqr(m1)+1);
  yp1:=m1*xp1+q1;
  q2:=-m2*xp1+yp1;
  for x2:=-(image.Width div 2) to (image.Width div 2) do
    begin
      y2:=round(-m2*x2+q2);
      Image.Canvas.Pixels[x2+(image.Width div 2),-y2+(Image.Height div 2)]:=clblue;
    end;
  a2:=arcsin(sin(a1)/(ii/iar));
  m3:=tan (degtorad(180)-a1+a2);
  q3:=+yp1-m3*xp1;
  for x3:=-(image.Width div 2) to (image.Width div 2) do
  begin
    y3:=round(m3*x3+q3);
    if Sqr(x3)+Sqr(y3)<Sqr(r) then
    Image.Canvas.Pixels[x3+(image.Width div 2),-y3+(Image.Height div 2)]:=clblue;
  end;
  m4:=tan(3*a2-a1);
  xp2:=(-m3*q3+sqrt(sqr(m3*q3)-(sqr(m3)+1)*(sqr(q3)-sqr(r))))/(sqr(m3)+1);
  yp2:=m3*xp2+q3;
  q4:=+yp2-m4*xp2;
  for x4:=-(image.Width div 2) to (image.Width div 2) do
    begin
      y4:=round(m4*x4+q4);
      if Sqr(x4)+Sqr(y4)<Sqr(r) then
      Image.Canvas.Pixels[x4+(image.Width div 2),-y4+(Image.Height div 2)]:=clblue;
    end;
  m5:=yp2/xp2;
  q5:=0;
  for x5:=0 to (image.Width div 2) do
    begin
      y5:=round(m5*x5+q5);
      Image.Canvas.Pixels[x5+(image.Width div 2),-y5+(Image.Height div 2)]:=clblue;
    end;
  xp3:=(-m4*q4-sqrt(sqr(m4*q4)-(sqr(m4)+1)*(sqr(q4)-sqr(r))))/(sqr(m4)+1);
  yp3:=m4*xp3+q4;
  xp4:=(q2-q5)/(m5-m2);
  yp4:=m5*xp4+q5;
  m6:=(yp3-yp4)/(xp3-xp4);
  q6:=yp4-m6*xp4;
  for x6:=-(image.Width div 2) to (image.Width div 2) do
    begin
      y6:=round(m6*x6+q6);
      Image.Canvas.Pixels[x6+(image.Width div 2),-y6+(Image.Height div 2)]:=clblue;
    end;
  xp5:=(-m4*q4-sqrt(sqr(m4*q4)-(sqr(m4)+1)*(sqr(q4)-sqr(r))))/(sqr(m4)+1);
  yp5:=m4*xp3+q4;
  m7:=yp5/xp5;
  q7:=0;
  if m7<0 then
    for x7:=0 to (image.Width div 2) do
      begin
        y7:=round(m7*x7+q7);
        if Sqr(x7)+Sqr(y7)<Sqr(r) then
        Image.Canvas.Pixels[x7+(image.Width div 2),-y7+(Image.Height div 2)]:=clblue;
      end
  else
    for x7:=-(image.Width div 2) to 0 do
       begin
        y7:=round(m7*x7+q7);
        if Sqr(x7)+Sqr(y7)<Sqr(r) then
        Image.Canvas.Pixels[x7+(image.Width div 2),-y7+(Image.Height div 2)]:=clblue;
      end;
  label6.visible:=true;
  LabelIndaco.Caption:=floattostr(arctan(m5));
  end;

  if checkboxViola.Checked = true then
  begin
  a1:=degtorad(strtofloat(labelededitAI.text));
  m1:=tan(degtorad(180)-a1);
  q1:=0;
  for x1:=-(image.Width div 2) to 0 do
    begin
      y1:=round(m1*x1+q1);
      if Sqr(x1)+Sqr(y1)<Sqr(r) then
      Image.Canvas.Pixels[x1+(image.Width div 2),-y1+(Image.Height div 2)]:=clpurple;
    end;
  m2:=0;
  xp1:=(-m1*q1-sqrt(sqr(m1*q1)-(sqr(m1)+1)*(sqr(q1)-sqr(r))))/(sqr(m1)+1);
  yp1:=m1*xp1+q1;
  q2:=-m2*xp1+yp1;
  for x2:=-(image.Width div 2) to (image.Width div 2) do
    begin
      y2:=round(-m2*x2+q2);
      Image.Canvas.Pixels[x2+(image.Width div 2),-y2+(Image.Height div 2)]:=clpurple;
    end;
  a2:=arcsin(sin(a1)/(ivi/iar));
  m3:=tan (degtorad(180)-a1+a2);
  q3:=+yp1-m3*xp1;
  for x3:=-(image.Width div 2) to (image.Width div 2) do
  begin
    y3:=round(m3*x3+q3);
    if Sqr(x3)+Sqr(y3)<Sqr(r) then
    Image.Canvas.Pixels[x3+(image.Width div 2),-y3+(Image.Height div 2)]:=clpurple;
  end;
  m4:=tan(3*a2-a1);
  xp2:=(-m3*q3+sqrt(sqr(m3*q3)-(sqr(m3)+1)*(sqr(q3)-sqr(r))))/(sqr(m3)+1);
  yp2:=m3*xp2+q3;
  q4:=+yp2-m4*xp2;
  for x4:=-(image.Width div 2) to (image.Width div 2) do
    begin
      y4:=round(m4*x4+q4);
      if Sqr(x4)+Sqr(y4)<Sqr(r) then
      Image.Canvas.Pixels[x4+(image.Width div 2),-y4+(Image.Height div 2)]:=clpurple;
    end;
  m5:=yp2/xp2;
  q5:=0;
  for x5:=0 to (image.Width div 2) do
    begin
      y5:=round(m5*x5+q5);
      Image.Canvas.Pixels[x5+(image.Width div 2),-y5+(Image.Height div 2)]:=clpurple;
    end;
  xp3:=(-m4*q4-sqrt(sqr(m4*q4)-(sqr(m4)+1)*(sqr(q4)-sqr(r))))/(sqr(m4)+1);
  yp3:=m4*xp3+q4;
  xp4:=(q2-q5)/(m5-m2);
  yp4:=m5*xp4+q5;
  m6:=(yp3-yp4)/(xp3-xp4);
  q6:=yp4-m6*xp4;
  for x6:=-(image.Width div 2) to (image.Width div 2) do
    begin
      y6:=round(m6*x6+q6);
      Image.Canvas.Pixels[x6+(image.Width div 2),-y6+(Image.Height div 2)]:=clpurple;
    end;
  xp5:=(-m4*q4-sqrt(sqr(m4*q4)-(sqr(m4)+1)*(sqr(q4)-sqr(r))))/(sqr(m4)+1);
  yp5:=m4*xp3+q4;
  m7:=yp5/xp5;
  q7:=0;
  if m7<0 then
    for x7:=0 to (image.Width div 2) do
      begin
        y7:=round(m7*x7+q7);
        if Sqr(x7)+Sqr(y7)<Sqr(r) then
        Image.Canvas.Pixels[x7+(image.Width div 2),-y7+(Image.Height div 2)]:=clpurple;
      end
  else
    for x7:=-(image.Width div 2) to 0 do
      begin
        y7:=round(m7*x7+q7);
        if Sqr(x7)+Sqr(y7)<Sqr(r) then
        Image.Canvas.Pixels[x7+(image.Width div 2),-y7+(Image.Height div 2)]:=clpurple;
      end;
  label7.visible:=true;
  LabelViola.Caption:=floattostr(arctan(m5));
  end;
bitbtnstart.Enabled:=false;
end;

end.
